function Papu = funECMS(in,Pd,p,CTRL_RES)

if Pd <= 0
    Papu = 0;
    return
end

umincap = (Pd - 15000)./Pd; % discharge power
umaxcap = (Pd + 10000)./Pd; % charge power
uminfc = 1000./Pd ; % minimum power
umaxfc = max(in.fcell.fcellPowCurve.x)./Pd ; % maximum power
umin = max([uminfc umincap]);
umax = min([umaxcap umaxfc]);

u = linspace(umin,umax,CTRL_RES);

m_dot_eng = interp1(in.fcell.fcellPowCurve.x,in.fcell.fcellPowCurve.y,u.*Pd);
m_dot_batt = m_dot_eng./u.*(1-u);
m_dot_batt(m_dot_batt>0) = m_dot_batt(m_dot_batt>0).*1.1;
m_dot_batt(m_dot_batt<0) = m_dot_batt(m_dot_batt<0).*0.9;

J = m_dot_eng + m_dot_batt.*p;

if umincap<=0
   J = [interp1(u,J,0,'linear','extrap') J];
   u = [0 u];   
end

u_min = u(find(J==min(J),1,'first'));

if isempty(u_min)
    u_min = 0;
end

Papu = Pd * u_min;

end