function IP = getIniPop(LB,UB,popDist,type)

% Type
% 1 - Random
% 2 - Uniform

nP = length(UB);

if type == 1
    popSize = popDist;
    IP = repmat(LB,popSize,1) + rand(popSize,nP).*repmat((UB-LB),popSize,1);
end

if type == 2
    popSize = 1;
    for i = 1:nP;
        popSize=popSize*popDist(i);
    end
    
    axesValues = zeros(max(popDist),nP);
    
    for i = 1:nP
        axesValues(1:popDist(i),i) = linspace(LB(i),UB(i),popDist(i))';
    end
    
    IP = zeros(popSize,nP);
    
    for i = 0:popSize-1
        idx = i;
        
        for j = 1:nP
            idxAxes = mod(idx,popDist(j))+1;
            idx = floor(idx/popDist(j));
            IP(i+1,j) = axesValues(idxAxes,j);
        end
        
    end
end
% keyboard;
IP = roundMe(IP,[1 1 1 1 1]); % Force individual to be integer only
IP = conditionIndividual(IP); % Condition individual based on powertrain type
end