function initME = initTankFC(stoScale)

initME.tank = tank(stoScale);

initME.costE = initME.tank.cost;
initME.massE = initME.tank.mass;

end


function tank = tank(tankSize)

tank.tankSize = 50;   % litres
tank.Hl = 44.4 * 10 ^ 6;    % Fuel lower heating value (J/kg)

tankBaseMass = 10;          % kg
fuelMass = 0.77 * tank.tankSize; % kg/l
fuelCost = 2.00 * tank.tankSize; % $/l

tank.mass = tankBaseMass + fuelMass;
tank.cost = fuelCost;

end
